#define MAX_TASKS  32

#ifndef DISPATCH_H
#define DISPATCH_H

typedef void (*dispatch_task_init)      (void *data);
typedef  int (*dispatch_task_iteration) (void *data);
typedef void (*dispatch_task_destroy)   (void *data);

typedef struct Dispatch
{
  int                     task_priority[MAX_TASKS];
  dispatch_task_iteration task_iteration[MAX_TASKS];
  void                   *task_data[MAX_TASKS];
  dispatch_task_destroy   task_destroy[MAX_TASKS];
  int   count;
} Dispatch;

Dispatch * dispatch_new      (void);
void       dispatch_add_task (Dispatch               *self,
                              int                     priority,
                              dispatch_task_init      init,
                              dispatch_task_iteration iteration,
                              dispatch_task_destroy   destroy,
                              void                   *data
                              );
void       dispatch_add_idle (Dispatch               *self,
                              dispatch_task_iteration iteration,
                              void                   *data);
int        dispatch_iterate  (Dispatch *self);
void       dispatch_destroy  (Dispatch *self);

#endif
