/* program to generate the akois database */

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>

#include "babl/babl.h"
#include "db.h"
#include "munin.h"
#include "digest.h"

static akois_db *db;

static void db_dump()
{
  fprintf (stderr, "\nduming database\n");
  system ("cp munin.db munin.db~");
  akois_db_save (db, "munin.db");
  akois_db_free (db);
  fprintf (stdout, "\n");
  exit (0);
}

static char *task=NULL;

void
vm_set_task (const char *new_task)
{
  if (task)
    free (task);
  task = strdup (new_task);
}

#include "SDL.h"

void     babl_fish_stats                (FILE           *file);
/*
 *  returns 0 if the key was intercepted and the current dispatched task
 *  should stop.
 */
int 
vm_key_handle (unsigned int sym)
{
   switch (sym)
     {
               case SDLK_d: /* debug babl (memory handling got out of hand at some point) */
                  {
                     char logfile_name[]="/tmp/babl-stats.html";
                     FILE *logfile;
                     logfile = fopen (logfile_name, "w");
                     if (logfile)
                       {
                        babl_fish_stats (logfile);
                        fclose (logfile);
                       }
                  }
                 break;
       case SDLK_F1:
         vm_set_task ("munin_splash");
         return 0;
       case SDLK_F2:
         vm_set_task ("munin_mirror");
         return 0;
       case SDLK_F3:
         vm_set_task ("munin_quadtree");
         return 0;
       case SDLK_F4:
         vm_set_task ("munin_ghost");
         return 0;
       case SDLK_F5:
         vm_set_task ("munin_mosaic");
         return 0;
       case SDLK_F6:
         vm_set_task ("munin_deja");
         return 0;
       case SDLK_F7:
         vm_set_task ("munin_debug");
         return 0;
       case SDLK_F10:
         fprintf (stderr, "sudden death\n");
         exit(-1);
       case SDLK_ESCAPE:
         vm_set_task ("quit");
         return 0;
       default:
         return 1;
     }
   return 1;
}

int
main (int    argc,
      char **argv)
{

  /*  
   *  Reentrant busybox vm, currently set up for single full task switching,
   *  could be expaned into a background / foreground task control as well by
   *  expanding on the parent structures.
   */
  { 
     int retval = 0;
 
     char *tmp       = strdup(argv[0]);
     vm_set_task (basename(tmp));
     free (tmp);

     while (strcmp (task, "quit"))
       {
         //babl_init ();  /*XXX:FIXME: hack to get around ref_counting gone astray :/ */

              if (!strcmp(task, "deja-vu"))     retval = munin_deja   (argc, argv);
         else if (!strcmp(task, "munin_eye"))      retval = munin_eye    (argc, argv);
         else if (!strcmp(task, "munin_debug"))    retval = munin_debug  (argc, argv);
         else if (!strcmp(task, "naa-av-da"))   retval = munin_mosaic (argc, argv);
         else if (!strcmp(task, "rekursiv-oppdeling")) retval = munin_quadtree (argc, argv);
         else if (!strcmp(task, "munin_splash"))   retval = munin_splash (argc, argv);
         else if (!strcmp(task, "ghost"))    retval = munin_ghost (argc, argv);
         else if (!strcmp(task, "speil"))   retval = munin_mirror (argc, argv);
              else if (!strcmp(task, "quit"))   {
                retval = munin_mirror (argc, argv);
                break;
              }
         else {
           printf ("undefined task '%s'\n", task);
           return -1;
         }

         SDL_Quit ();
       }
     free (task);

     return retval;
  }
  return 0;




  db = akois_db_new ();

  { /* check for presence of database, and load it if present */
    FILE *fp;
    fp = fopen ("munin.db", "r");
    if (fp)
      {
        fclose (fp);
        akois_db_load (db, "munin.db");
      }
  }

  fprintf (stderr, "digest:  %s\n", akois_digest_get_type ());
  signal(SIGINT, db_dump);
  akois_db_add_images (db, "images/*.png");
  akois_db_add_images (db, "images/*.jpeg");
  db_dump();

  fprintf (stdout, "\n");
  return 0;
}
