#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "options.h"

struct _akois_options
{
  int    results;
  int    depth;
  int    neighbourhood;
  double luminance;
  double chrominance;
  double complexity;

  double alpha;
  double beta;
  double gamma;

  int    temporal_shadow;
  char  *pattern;
};


akois_options *
akois_options_new (void)
{
  akois_options *self;

  self = calloc (1, sizeof(struct _akois_options));

  self->luminance   = 1.0;
  self->chrominance = 7.0;
  self->complexity  = 100.0;
  self->neighbourhood = 0;
  self->depth       = 5;

  self->alpha       = 1.0;
  self->beta        = 1.0;
  self->gamma       = 1.0;

  self->temporal_shadow = 0;
  self->pattern = strdup (".*");
  return self;
}

void
akois_options_free (akois_options *self)
{
  free (self);
}

void
akois_options_set_results (akois_options *self,
                         int            results)
{
  self->results=results;
}

int
akois_options_get_results (akois_options *self)
{
  return self->results;
}


void
akois_options_set_temporal_shadow (akois_options *self,
                         int            temporal_shadow)
{
  self->temporal_shadow=temporal_shadow;
}

int
akois_options_get_temporal_shadow (akois_options *self)
{
  return self->temporal_shadow;
}

void
akois_options_set_depth (akois_options *self,
                         int            depth)
{
  self->depth=depth;
}

int
akois_options_get_depth (akois_options *self)
{
  return self->depth;
}


void
akois_options_set_neighbourhood (akois_options *self,
                                 int            neighbourhood)
{
  self->neighbourhood=neighbourhood;
}

int
akois_options_get_neighbourhood (akois_options *self)
{
  return self->neighbourhood;
}


void
akois_options_set_luminance (akois_options *self,
                             double         luminance)
{
  self->luminance=luminance;
}

double
akois_options_get_luminance (akois_options *self)
{
  return self->luminance;
}


void
akois_options_set_chrominance (akois_options *self,
                               double         chrominance)
{
  self->chrominance=chrominance;
}

double
akois_options_get_chrominance (akois_options *self)
{
  return self->chrominance;
}


void
akois_options_set_complexity (akois_options *self,
                              double         complexity)
{
  self->complexity=complexity;
}

double
akois_options_get_complexity (akois_options *self)
{
  return self->complexity;
}



void
akois_options_set_alpha (akois_options *self,
                         double         alpha)
{
  self->alpha=alpha;
}

double
akois_options_get_alpha (akois_options *self)
{
  return self->alpha;
}


void
akois_options_set_beta (akois_options *self,
                        double         beta)
{
  self->beta=beta;
}

double
akois_options_get_beta (akois_options *self)
{
  return self->beta;
}

void
akois_options_set_gamma (akois_options *self,
                         double         gamma)
{
  self->gamma=gamma;
}

double
akois_options_get_gamma (akois_options *self)
{
  return self->gamma;
}

